<?php

/***************************************************************************
 *                                bbcode.inc..php
 *                            -------------------
 *   Begin                : Dinsdag, 8 Juni, 2004
 *   Copyright            : Martin van Dijk
 *   Omschrijving:        : BBcode parsing function
 *
 ***************************************************************************/

if(!defined('IN_CT')){
	die('Hacking attempt');
}

include('includes/smilies.inc.php');

function bbcode($content, $me_username){ // De $username is bedoeld voor in een eventuele /me tage
	
	global $smiliepath;
	global $smilies;

	$content = nl2br( htmlspecialchars( stripslashes($content) ) );
	
	/* Smilies omzetten */
	foreach($smilies as $key => $value){ 
		$content = str_replace($key, "<img class='noborder' src='".$value."' alt='' />", $content); 
	}
	
	/* De 'searchhighlight' */
	if(isset($_GET['highlight'])){
		$terms = explode(" ", $_GET['highlight']);
		foreach($terms as $word){
			$content = str_replace($word, "<span class='highlight'>".$word."</span>", $content);
		}
	}
	
	/* Als er geen "[" tags te vinden zijn, kappen we d'r direct mee */
	if ( strpos($content, "[") === false ){
		return $content;
	}
	
	$patterns = array(); 
		$replacements = array();
		
		$patterns[0] = "#\[url\]([a-z]+?://){1}(.*?)\[/url\]#si"; 
	$replacements[0] = '<a href="\1\2">\1\2</a>'; 
	
		$patterns[1] = "#\[url\](.*?)\[/url\]#si"; 
	$replacements[1] = '<a href="http://\1">\1</a>'; 
	
		$patterns[2] = "#\[url=([a-z]+?://){1}(.*?)\](.*?)\[/url\]#si"; 
	$replacements[2] = '<a href="\1\2">\3</a>';  
	  
		$patterns[3] = "#\[url=(.*?)\](.*?)\[/url\]#si"; 
	$replacements[3] = '<a href="http://\1">\2</a>'; 
	
		$patterns[4] = "#\[email\](.*?)\[/email\]#si"; 
	$replacements[4] = '<a href="mailto:\1">\1</a>'; 
	
		$patterns[5] = "#\[email=(.*?)\](.*?)\[/email\]#si"; 
	$replacements[5] = '<a href="mailto://\1">\2</a>';
	
		$patterns[6] = "#\[img=(.*?)\](.*?)\[/img\]#si"; 
	$replacements[6] = '<img src="\2" alt="\1" />';   
	
		$patterns[7] = "#\[color=(.*?)\](.*?)\[/color\]#si"; 
	$replacements[7] = '<font color="\1">\2</font>';
		
		$patterns[8] = "#\[size=(.*?)\](.*?)\[/size\]#si"; 
	$replacements[8] = '<font size="\1">\2</font>';
		
	$content = preg_replace($patterns, $replacements, $content);
	
	/* Geld alleen maakt niet gelukkig. Je hebt ook aandelen, obligaties, goud en onroerend goed nodig */
	
	$content = preg_replace("/\[center\](.*?)\[\/center\]/si", "<div class='center'>\\1</div>", $content); 
	$content = preg_replace("/\[b\](.*?)\[\/b\]/si", "<b>\\1</b>", $content); 
	$content = preg_replace("/\[h1\](.*?)\[\/h1\]/si", "<h1>\\1</h1>", $content); 
	$content = preg_replace("/\[h2\](.*?)\[\/h2\]/si", "<h2>\\1</h2>", $content);
	$content = preg_replace("/\[i\](.*?)\[\/i\]/si", "<em>\\1</em>", $content); 
	$content = preg_replace("/\[u\](.*?)\[\/u\]/si", "<u>\\1</u>", $content); 
	$content = preg_replace("/\[s\](.*?)\[\/s\]/si", "<strike>\\1</strike>", $content);
	$content = preg_replace("/\[p\](.*?)\[\/p\]/si", "<p>\\1</p>", $content);
	$content = preg_replace("/\[ul\](.*?)\[\/ul\]/si", "<ul>\\1</ul>", $content);
	$content = preg_replace("/\[ol\](.*?)\[\/ol\]/si", "<ul>\\1</ul>", $content);
	$content = preg_replace("/\[li\](.*?)\[\/li\]<br \/>/si", "<li>\\1</li>", $content);
	$content = preg_replace("/\[code\](.*?)\[\/code\]/si", "<pre>\\1</pre>", $content);
	$content = preg_replace("/\[php\](.*?)\[\/php\]/si", "<pre>\\1</pre>", $content);
	$content = preg_replace("/\[quote\](.*?)\[\/quote\]/si", "<div class='quote'>\\1</div>", $content); 
	$content = preg_replace("/\[ot\](.*?)\[\/ot\]/si", "<span class='offtopic'>\\1</span>", $content);
	$content = preg_replace("/\[offtopic\](.*?)\[\/offtopic\]/si", "<span class='offtopic'>\\1</span>", $content); 
	$content = preg_replace("/\[img\](.*?)\[\/img\]/si", "<img src='\\1' onload='image_resize(this)' alt='' />", $content);
	$content = preg_replace("/\[img left\](.*?)\[\/img\]/si", "<img class='left' src='\\1' onload='image_resize(this)' alt='' />", $content);
	$content = preg_replace("/\[img right\](.*?)\[\/img\]/si", "<img class='right' src='\\1' onload='image_resize(this)' alt='' />", $content);
	$content = preg_replace("/\[img center\](.*?)\[\/img\]/si", "<div class='center'><img src='\\1' onload='image_resize(this)' alt='' /></div>", $content);
			
	return $content;
}

function bbcode_sig($sig, $htmlstrip){
	
	/* Deze functie verwerkt de beperkte BB code in de gebruikers 'sig' */
	
	if($htmlstrip == 1){
		$sig = htmlspecialchars( stripslashes($sig) );
	}
		
	$sig = preg_replace("/\[b\](.*?)\[\/b\]/si", "<b>\\1</b>", $sig);
	$sig = preg_replace("/\[u\](.*?)\[\/u\]/si", "<u>\\1</u>", $sig);
	$sig = preg_replace("/\[i\](.*?)\[\/i\]/si", "<i>\\1</i>", $sig);
	$sig = preg_replace("/\[s\](.*?)\[\/s\]/si", "<strike>\\1</strike>", $sig); 
		
		$patterns = array(); 
	$replacements = array();
		
		$patterns[0] = "#\[url\]([a-z]+?://){1}(.*?)\[/url\]#si"; 
	$replacements[0] = '<a href="\1\2">\1\2</a>'; 
	
		$patterns[1] = "#\[url\](.*?)\[/url\]#si"; 
	$replacements[1] = '<a href="http://\1">\1</a>'; 
	
		$patterns[2] = "#\[url=([a-z]+?://){1}(.*?)\](.*?)\[/url\]#si"; 
	$replacements[2] = '<a href="\1\2">\3</a>';  
	  
		$patterns[3] = "#\[url=(.*?)\](.*?)\[/url\]#si"; 
	$replacements[3] = '<a href="http://\1">\2</a>'; 
	
		$patterns[4] = "#\[email\](.*?)\[/email\]#si"; 
	$replacements[4] = '<a href="mailto:\1">\1</a>'; 
	
		$patterns[5] = "#\[email=(.*?)\](.*?)\[/email\]#si"; 
	$replacements[5] = '<a href="mailto://\1">\2</a>';
					
	$sig = preg_replace($patterns, $replacements, $sig);

	return $sig;
}

?>