<?php

/***************************************************************************
 *                                zoeken.php
 *                            -------------------
 *   Begin                : Dinsdag, 22 Juni, 2004
 *   Copyright            : Martin van Dijk
 *   Omschrijving:        : Doorzoekt het forum
 *
 ***************************************************************************/

/***************************************************************************
 *                                
 *   Allereerst wil ik er even op wijzen dat de zoekfunctie van Cool Topix
 *   werkt via de MySQL LIKE functie, in plaats van de *snellere* FULLTEXT.
 *   Dit omdat naar mijn weten de LIKE functie vele malen flexibeler is dan
 *   de FULLTEXT, en bovendien niet afhankelijk is van de MySQL versie of
 *   een FULLTEXT index op tabellen (al is dit niet zo'n groot probleem).
 *   
 *   Okay, FULLTEXT is sneller, maar LIKE is veelzijdiger en effectiever.
 *   Het verschil in snelheid zul je echter pas gaan merken als er tabellen
 *   met honderdduizenden posts doorzocht moeten worden. Niet echt iets om
 *   van wakker te liggen dus... 
 *
 *   Mocht iemand zich geroepen voelen een FULLTEXT zoekmod te bouwen voor
 *   Cool Topix, graag! Deze kan altijd extra als mod aangeboden worden.
 *   Voorlopig gaan we gewoon verder met LIKE :-)
 *
 ***************************************************************************/

include('includes/headers.php');

if(isset($_GET['zoek']) && strlen(trim($_GET['zoek'])) > 2 // Minimaal 3 tekens 
	&& isset($_GET['op']) // Zoeken op (titel, inhoud, gebruiker)
	&& isset($_GET['in']) // Zoeken in (subforum)
	&& isset($_GET['order']) // DESC of ASC
	&& isset($_GET['enof']) // AND / OR
	&& isset($_GET['sort']) // Sorteren op
	){
		
	$term = explode(' ', $_GET['zoek']);
	$aantal_termen = count($term); // Zoektermen
	
	switch($_GET['op']){ // Zoeken in veld
		case 'titel': $op = 't.titel'; break;
		case 'inhoud': $op = 'p.text'; break;
		default: $op = 't.titel'; break;
	}
	
	switch($_GET['enof']){ // AND / OR
		case 'en': $enof = 'AND'; break;
		case 'of': $enof = 'OR'; break;
		default: $enof = 'AND'; break;
	} 	
	
	switch($_GET['sort']){ // ORDER BY (Deel 1)
		case 'id': $sort = 't.id'; break;
		case 'datum': $sort = 't.datum'; break;
		case 'laatstereply': $sort = 't.laatstepost'; break;
		case 'aantalreplys': $sort = 't.replys'; break;
		case 'views': $sort = 't.views'; break;
		default: $sort = 't.id'; break;
	} 	

	switch($_GET['order']){ // ORDER BY (Deel 2)
		case 'desc': $order = 'DESC'; break;
		case 'asc': $order = 'ASC'; break;
		default: $order = 'DESC'; break;
	}
	
	switch($_GET['in']){ // WHERE sub_id = ?
		case 'all': $in = ''; break;		
		default: $in = "AND t.sub_id = '".$_GET['in']."' "; break;
	} 
	
	/* 
		We hebben nu: $term (array), $op, $sort, $order en $in  
		Tijd voor koffie!
	*/
	
	$paginatitel = 'Zoeken naar: '.htmlspecialchars($_GET['zoek']);
	include('header.php');
	
	$dt = new ParseTemplate;
	$dt->gettemp('zoeken_output.tpl','zoek');
				
	$dt->addvar('zoek', 'termen', htmlspecialchars(stripslashes($_GET['zoek'])));

	$sql = "SELECT id
			FROM ".$db['prefix']."subs 
			WHERE modforum = 1";
	$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
	if(isset($res)){ // De modforums in een array plaatsen
		$modforums_array = mysql_fetch_assoc($res);
	}
	
	// De zoekopdrachten opbouwen...

	switch($op){
		case 't.titel': // We gaan zoeken op topic titel! Whoei!
		
			$sql = "SELECT t.id, t.titel, t.replys, t.views, t.slot, t.sticky, t.sub_id, t.faq, 
							DATE_FORMAT( t.laatstepost, '%d.%m.%y %H:%i' ) AS laatstepost 
					FROM ".$db['prefix']."topics t 
					WHERE ";
					
			for($i = 0; $i < $aantal_termen; $i++){ // Alle zoektermen toevoegen
				$sql .= "t.titel LIKE '%".$term[$i]."%' ".$enof." ";
			}
			
			switch($enof){ // De laatste AND of OR eraf knippen
				case 'AND': $sql = substr($sql, 0, -4)." \n"; break;
				case 'OR': $sql = substr($sql, 0, -3)." \n"; break;
			}
						
			$sql .= $in; // Als er een subforum geselecteerd is, zoek dan enkel in deze.
			
			$sql .= "ORDER BY ".$sort." ".$order." \n";
			
			$sql .= "LIMIT 0, ".$_SESSION['max_topics_in_sub'];
			
		break;
		
		case 'p.text': // We gaan zoeken op topic inhoud! Meeuuhhh!
					
			$sql = "SELECT t.id, t.titel, t.replys, t.views, t.slot, t.sticky, t.sub_id, t.faq, 
							DATE_FORMAT( t.laatstepost, '%d-%m-%y %H:%i' ) AS laatstepost 
					FROM ".$db['prefix']."topics t 
					LEFT JOIN ".$db['prefix']."posts p 
					ON p.topic_id = t.id 
					WHERE \n";
					
			for($i = 0; $i < $aantal_termen; $i++){ // Alle zoektermen toevoegen
				$sql .= "p.text LIKE '%".$term[$i]."%' ".$enof." ";
			}
			
			switch($enof){ // De laatste AND of OR eraf knippen
				case 'AND': $sql = substr($sql, 0, -4)." \n"; break;
				case 'OR': $sql = substr($sql, 0, -3)." \n"; break;
			}
					
			$sql .= $in; // Als er een subforum geselecteerd is, zoek dan enkel in deze.
			
			 
			// Voor deze query doen we altijd sorteren op ID, om correct te kunnen groeperen 						
			$sql .= "GROUP BY t.id ".$order." \n";
			
			$sql .= "LIMIT 0, ".$_SESSION['max_topics_in_sub'];
		
		break;
	}
	
	function titel_strip($i){ 
		if(strlen($i) > 50){ 
			$k = substr($i, 0, 50); 
			$ls = strrpos($k, ' '); 
			$k = substr($k, 0, $ls);  
			$i =  $k.'...'; 
			return $i; 
		} 
		else{ 
			return $i; 
		} 
	}
	
	$class = 'kleur2';
	
	// Ohjeej, de zoekopdracht word uitgevoerd!.. Spannend!!!
	$begin_query_zoeken = ParseTime();
	$result = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
	$eind_query_zoeken = ParseTime();
	$query_duur = substr($eind_query_zoeken - $begin_query_zoeken, 0, 8);
	if(isset($result)){
		
		$aantal_resultaten = number_format(mysql_num_rows($result));
		$dt->addvar('zoek', 'aantal_resultaten', $aantal_resultaten);
		$dt->addvar('zoek', 'query_duur', $query_duur);
		
			while($r = mysql_fetch_assoc($result)){
		
				if($r['faq'] == 1){
					$topic_map_img = 'sub_faq'; 
					$topic_map_alt = 'FAQ topic'; 
					$tag = '<span class="faq_topic"> [FAQ] ';
					$tag_end = '</span>';
				}
				elseif($r['sticky'] == 1){
					$topic_map_img = 'sub_sticky'; 
					$topic_map_alt = 'Sticky topic'; 
					$tag = '<span class="sticky_topic">';
					$tag_end = '</span>';
				}
				elseif($r['slot'] == 1){
					$topic_map_img = 'sub_slot'; 
					$topic_map_alt = 'Topic gesloten';
					$tag = '';
					$tag_end = '';
				}
				else{ 
					$topic_map_img = (isset($_COOKIE[md5($_SESSION['forum_naam']).'_ct_topic'.$r['id']]) && $_COOKIE[md5($_SESSION['forum_naam']).'_ct_topic'.$r['id']] != $r['replys']) ? "sub_mapje_rood" : "sub_mapje";
					$topic_map_alt = 'Topic';
					$tag = '';
					$tag_end = '';
				}
				
				if( (is_array($modforums_array) && !in_array($r['sub_id'], $modforums_array) ) || !is_array($modforums_array)  ){
					
					// Pars het hele zootje!
					$dt->parse('RESULT');
					$dt->addvar('RESULT', 'class', $class);
					$dt->addvar('RESULT', 'topic_id', $r['id']);
					$dt->addvar('RESULT', 'topic_map_img', $topic_map_img);
					$dt->addvar('RESULT', 'topic_map_alt', $topic_map_alt);
					$dt->addvar('RESULT', 'topic_titel', $tag.htmlspecialchars(stripslashes(titel_strip($r['titel']))).$tag_end);
					$dt->addvar('RESULT', 'topic_replys', $r['replys']);
					$dt->addvar('RESULT', 'topic_views', number_format($r['views']));
					$dt->addvar('RESULT', 'topic_laatstepost', $r['laatstepost']);
					$dt->addvar('RESULT', 'highlight_term', addslashes($_GET['zoek']));		
					
					$class = ($class == 'kleur2') ? 'kleur3' : 'kleur2';
				}
			}
	}
	
	$dt->display('zoek');
	
	include('footer.php');		
}
else{

	$paginatitel = 'Zoeken';
	include('header.php');
	
	$sub_jump_options = '';
	$sql = "SELECT id, titel 
			FROM ".$db['prefix']."subs 
			WHERE modforum = '0' 
			ORDER BY titel ASC ";
			
	$res = mysql_query($sql) or die(mysql_error()."<hr><pre>".$sql."</pre>");
	if(isset($res)){
		$sub_jump_options .= "<option value='all'>Alle subforums</option>";
		while($j = mysql_fetch_assoc($res)){
			$sub_jump_options .= "<option value='".$j['id']."'>&raquo; ".htmlspecialchars(stripslashes($j['titel']))."</option>";
		}
	}
	
	$dt = new ParseTemplate;
	$dt->gettemp('zoeken_form.tpl','zoek');
				
	$dt->addvar('zoek', 'jumpbox', $sub_jump_options);

	$dt->display('zoek');
	
	include('footer.php');
}

?>